// Programmer: INSERT YOUR NAME
// Assignment: Program 4

/********************************************************************
 * Card
 *
 * Member Variables: 
 *   INSERT DESCRIPTION OF MEMBER VARIABLES
 * Private Methods: 
 *   INSERT DESCRIPTION OF PRIVATE METHODS (IF ANY)
 * Public Methods: 
 *   INSERT DESCRIPTION OF PUBLIC METHODS (IF ANY)
 *******************************************************************/
 
    public class Card
   {
      // constants representing the suits
      public static final int HEARTS = 0;
      public static final int CLUBS = 1;
      public static final int DIAMONDS = 2;
      public static final int SPADES = 3;
   
      // constants representing the named faces
      public static final int JACK = 11;
      public static final int QUEEN = 12;
      public static final int KING = 13;
      public static final int ACE = 14;
   
      // member variabes
		
      /* INSERT MEMBER VARIABLES HERE */
		int suit, face;
   
      /******************************************************
       * Card Constructor
       *
       * INSERT DESCRIPTION OF CONSTRUCTOR HERE
       ******************************************************/
       public Card (int _face, int _suit)
      {
         // initialize the card
			suit = _suit;
			face = _face;
      }
		
		public void setCard(String _face, String _suit)
		{
			if (_face.equals("Ace"))
				face = ACE;
			else if (_face.equals("King"))
				face = KING;
			else if (_face.equals("Queen"))
				face = QUEEN;
			else if (_face.equals("Jack"))
				face = JACK;
			else
				face = 0;
				
			setSuit(_suit);
		}

		public void setCard(int _face, String _suit)
		{
			face = _face;
			
			setSuit(_suit);
		}
				
		public Card(String _face, String _suit)
		{
			setCard(_face, _suit);
		}
				
		public Card(int _face, String _suit)
		{
			setCard(_face, _suit);
		}
		
		public Card()
		{
			face = 2;
			setSuit("Hearts");
		}
		
		public void setSuit(String _suit)
		{
			if (_suit.equals("Hearts"))
					suit = HEARTS;
				else if (_suit.equals("Clubs"))
					suit = CLUBS;
				else if (_suit.equals("Diamonds"))
					suit = DIAMONDS;
				else if (_suit.equals("Spades"))
					suit = SPADES;	
				else suit = 0;	
		}
		
		public String faceToString()
		{
			if (face > 10)
			{
				switch(face % 10)
				{
					case 1: return "Jack";
					case 2: return "Queen";
					case 3: return "King";
					case 4: return "Ace";
					default: return "Unknown";
				}
			}
			
			return Integer.toString(face);
		}
		
		public String suitToString()
		{
			switch(suit % 4)
			{
				case 0: return "Hearts";
				case 1: return "Clubs";
				case 2: return "Diamonds";
				case 3: return "Spades";
			}
			
			return "Unknown";
		}
      /*****************************************************
       * toString
       *
       * INSERT DESCRIPTION OF METHOD HERE
       *****************************************************/
       public String toString ()
      {
         // return a String that contains a text representation of the card
         // examples: King of Spades, 2 of Hearts
         
			return faceToString() + " of " + suitToString();
         
      }
   
      /******************************************************
       * getFace
       *
       * INSERT DESCRIPTION OF METHOD HERE
       ******************************************************/
       public int getFace() 
      {
         return face;
      }
		
		public boolean isFaceCard()
		{
		 	if (face > 10)
				return true;
			else
				return false;
		}
		
      /******************************************************
       * getSuit
       *
       * INSERT DESCRIPTION OF METHOD HERE
       ******************************************************/
       public int getSuit()
      {
         return suit;
      }
   
   } // end of class Card